#include <windows.h>
#include <math.h>
#include <stdio.h>

extern "C" __declspec( dllexport ) DWORD __stdcall Smooth (float *aPnt, DWORD iPoints, DWORD iSteps);

float SmoothPoint(float P1, float P2, float P3, float P4, float t)
{
      float V1, V2, V3, V4;
      V1 = (-P1 + 3 * P2 - 3 * P3 + P4) / 6.0;
	  V2 = (3 * P1 - 6 * P2 + 3 * P3) / 6.0;
 	  V3 = (-3 * P1 + 3 * P3) / 6.0;
	  V4 = (P1 + 4 * P2 + P3) / 6.0;
	  return (V3 + t * (V2 + t * V1)) * t + V4;     
}

extern "C" DWORD __stdcall Smooth (float *aPnt, DWORD iPoints, DWORD iSteps)
{
       DWORD iStep, iMax, iLoop;
       iMax = (iPoints - 1) * 2;
       for (iStep=0; iStep<iSteps; ++iStep)
       {
           aPnt[0] = SmoothPoint(aPnt[iMax], aPnt[0], aPnt[2], aPnt[4], 0.5);
           aPnt[1] = SmoothPoint(aPnt[iMax+1], aPnt[1], aPnt[3], aPnt[5], 0.5);
           for (iLoop=2; iLoop<iMax - 2; iLoop += 2)
           {
               aPnt[iLoop] = SmoothPoint(aPnt[iLoop-2], aPnt[iLoop], aPnt[iLoop + 2], aPnt[iLoop + 4], 0.5);
               aPnt[iLoop+1] = SmoothPoint(aPnt[iLoop-1], aPnt[iLoop+1], aPnt[iLoop + 3], aPnt[iLoop + 5], 0.5);
           }
           aPnt[iMax-2] = SmoothPoint(aPnt[iMax-4], aPnt[iMax-2], aPnt[iMax], aPnt[0], 0.5);
           aPnt[iMax-1] = SmoothPoint(aPnt[iMax-3], aPnt[iMax-1], aPnt[iMax+1], aPnt[1], 0.5);
           aPnt[iMax] = SmoothPoint(aPnt[iMax-2], aPnt[iMax], aPnt[0], aPnt[2], 0.5);
           aPnt[iMax+1] = SmoothPoint(aPnt[iMax-1], aPnt[iMax+1], aPnt[1], aPnt[3], 0.5);
       }
       return 1;
}

BOOL APIENTRY DllMain (HINSTANCE hInst, DWORD reason, LPVOID reserved)
{
    return TRUE;
}
