library Smooth;

type
  tPnt = array[0..0] of single;

  function SmoothPoint(P1, P2, P3, P4, t: single): single;
  var
    V1, V2, V3, V4: single;
  begin
    V1 := (-P1 + 3 * P2 - 3 * P3 + P4) / 6.0;
    V2 := (3 * P1 - 6 * P2 + 3 * P3) / 6.0;
    V3 := (-3 * P1 + 3 * P3) / 6.0;
    V4 := (P1 + 4 * P2 + P3) / 6.0;
    Result := (V3 + t * (V2 + t * V1)) * t + V4;
  end;

  function Smooth(pPnt: Pointer; iPoints, iSteps: DWord): Dword; stdcall;
  var
    aPnt: ^tPnt absolute pPnt;
    iStep, iMax, iLoop: DWord;
  begin

    iMax := (iPoints - 1) * 2;
    for iStep := 1 to iSteps do
    begin
      aPnt^[0] := SmoothPoint(aPnt^[iMax], aPnt^[0], aPnt^[2], aPnt^[4], 0.5);
      aPnt^[1] := SmoothPoint(aPnt^[iMax + 1], aPnt^[1], aPnt^[3], aPnt^[5], 0.5);
      iLoop := 2;
      while iLoop < (iMax - 3) do
      begin
        aPnt^[iLoop] := SmoothPoint(aPnt^[iLoop - 2], aPnt^[iLoop], aPnt^[iLoop + 2],
          aPnt^[iLoop + 4], 0.5);
        aPnt^[iLoop + 1] := SmoothPoint(aPnt^[iLoop - 1], aPnt^[iLoop + 1],
          aPnt^[iLoop + 3], aPnt^[iLoop + 5], 0.5);
        iLoop += 2;
      end;
      aPnt^[iMax - 2] := SmoothPoint(aPnt^[iMax - 4], aPnt^[iMax - 2], aPnt^[iMax], aPnt^[0], 0.5);
      aPnt^[iMax - 1] := SmoothPoint(aPnt^[iMax - 3], aPnt^[iMax - 1], aPnt^[iMax + 1],
        aPnt^[1], 0.5);
      aPnt^[iMax] := SmoothPoint(aPnt^[iMax - 2], aPnt^[iMax], aPnt^[0], aPnt^[2], 0.5);
      aPnt^[iMax + 1] := SmoothPoint(aPnt^[iMax - 1], aPnt^[iMax + 1], aPnt^[1], aPnt^[3], 0.5);
    end;

    Result := 1;
  end;


exports Smooth;

begin
end.

