#include <GDIPlus.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>

#include ".\AutoIt\Smooth.au3"
Global $aDll[10][3] = [[5]]
$aDll[1][0] = DllOpen(@ScriptDir & "\FreeBasic\Smooth.dll")
$aDll[1][1] = "FreeBasic"
$aDll[1][2] = "Smooth"
$aDll[2][0] = DllOpen(@ScriptDir & "\Lazarus\Smooth.dll")
$aDll[2][1] = "Lazarus"
$aDll[2][2] = "Smooth"
$aDll[3][0] = DllOpen(@ScriptDir & "\FreePascal\Smooth.dll")
$aDll[3][1] = "FreePascal"
$aDll[3][2] = "Smooth"
$aDll[4][0] = DllOpen(@ScriptDir & "\DevC\Smooth.dll")
$aDll[4][1] = "DevC"
$aDll[4][2] = "Smooth"
$aDll[5][0] = DllOpen(@ScriptDir & "\MinGW\Smooth.dll")
$aDll[5][1] = "MinGW"
$aDll[5][2] = "Smooth@12"

Global $iSteps = 10
Global $iPoints = 10000

Opt("MustDeclareVars", 1)
Opt("GUIOnEventMode", 1)

Global $iWidth = @DesktopWidth * 0.8
Global $iHeight = @DesktopHeight * 0.8

_GDIPlus_Startup()
Global $hGui = GUICreate("Test", $iWidth, $iHeight)
GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")
Global $hGraphics = _GDIPlus_GraphicsCreateFromHWND($hGui)
Global $hBmpBuffer = _GDIPlus_BitmapCreateFromGraphics($iWidth, $iHeight, $hGraphics)
Global $hGfxBuffer = _GDIPlus_ImageGetGraphicsContext($hBmpBuffer)
_GDIPlus_GraphicsSetSmoothingMode($hGfxBuffer, 2)
_GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)

Global $hPen = _GDIPlus_PenCreate(0xFF00FF00, 1)

GUIRegisterMsg($WM_PAINT, "WM_PAINT")
GUISetState()

Global $aPoints = _CreateRandomPoints($iWidth, $iHeight, $iPoints)
Global $tPoints = _CreatePointsStruct($aPoints)

_GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)
DllCall($ghGDIPDll, "uint", "GdipDrawClosedCurve2", "hwnd", $hGfxBuffer, "hwnd", $hPen, "ptr", DllStructGetPtr($tPoints), "int", $iPoints, "float", 0)
_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
MsgBox(0, "original curve", "click ok to start...")

ConsoleWrite("!==============================================" & @CRLF)
_Smooth_Autoit($aPoints)
For $i = 1 To $aDll[0][0]
	_Smooth_Dll($aDll[$i][0], $aDll[$i][1], $aDll[$i][2], $tPoints)
Next
ConsoleWrite("!==============================================" & @CRLF)

While 1
	Sleep(10)
WEnd


Func _Smooth_Dll($hDll, $sText, $sFunc, $tSrcPnts)
	Local $tBytes = DllStructCreate("byte[" & DllStructGetSize($tSrcPnts) & "];", DllStructGetPtr($tSrcPnts))
	Local $bBytes = DllStructGetData($tBytes, 1)
	Local $tPoints = DllStructCreate("float[" & $iPoints * 2 & "];")
	$tBytes = DllStructCreate("byte[" & DllStructGetSize($tPoints) & "];", DllStructGetPtr($tPoints))
	DllStructSetData($tBytes, 1, $bBytes)
	Local $pPoints = DllStructGetPtr($tPoints)
	Local $fTime
	Local $iTimer = TimerInit()
	DllCall($hDll, "dword", $sFunc, "ptr", $pPoints, "dword", $iPoints, "dword", $iSteps)
	If @error Then
		ConsoleWrite("! Error calling " & $sText & " dll" & @CRLF)
		Return
	EndIf
	$fTime = TimerDiff($iTimer)
	ConsoleWrite("> " & $sText & ": " & $fTime & @CRLF)
	_GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)
	DllCall($ghGDIPDll, "uint", "GdipDrawClosedCurve2", "hwnd", $hGfxBuffer, "hwnd", $hPen, "ptr", DllStructGetPtr($tPoints), "int", $iPoints, "float", 0.5)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	MsgBox(0, $sText, $fTime)
EndFunc   ;==>_Smooth_Dll



Func _Smooth_Autoit($aPoints)
	Local $fTime
	Local $iTimer = TimerInit()
	_Smooth($aPoints, $iSteps)
	$fTime = TimerDiff($iTimer)
	ConsoleWrite("> AutoIt: " & $fTime & @CRLF)
	Local $tPoints = _CreatePointsStruct($aPoints)
	_GDIPlus_GraphicsClear($hGfxBuffer, 0xFF000000)
	DllCall($ghGDIPDll, "uint", "GdipDrawClosedCurve2", "hwnd", $hGfxBuffer, "hwnd", $hPen, "ptr", DllStructGetPtr($tPoints), "int", $iPoints, "float", 0.5)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	MsgBox(0, "AutoIt", $fTime)
EndFunc   ;==>_Smooth_Autoit









Func _CreateRandomPoints($iW, $iH, $iC, $iType = 2)
	Local $aPoints[$iC + 1][2] = [[$iC]]
	Switch $iType
		Case 1
			For $i = 1 To $iC
				$aPoints[$i][0] = Random(0, $iW)
				$aPoints[$i][1] = Random(0, $iH)
			Next
		Case Else
			Local $iR = 10
			Local $iX, $iY, $iTX, $iTY, $iStep = 0
			$iX = Random(0, $iW)
			$iY = Random(0, $iH)
			While 1
				$iTX = Random(0, $iW, 1)
				$iTY = Random(0, $iH, 1)
				For $i = 1 To $iR
					$iStep += 1
					If $iStep > $iC Then Return $aPoints
					$aPoints[$iStep][0] = $iX + ($i * ($iTX - $iX) / $iR) + Random(-20, 20)
					$aPoints[$iStep][1] = $iY + ($i * ($iTY - $iY) / $iR) + Random(-20, 20)
				Next
				$iX = $iTX
				$iY = $iTY
			WEnd
	EndSwitch
	Return $aPoints
EndFunc   ;==>_CreateRandomPoints

Func _CreatePointsStruct($aPoints)
	Local $tPoints = DllStructCreate("float[" & $aPoints[0][0] * 2 & "];")
	For $i = 1 To $aPoints[0][0]
		DllStructSetData($tPoints, 1, $aPoints[$i][0], ($i - 1) * 2 + 1)
		DllStructSetData($tPoints, 1, $aPoints[$i][1], ($i - 1) * 2 + 2)
	Next
	Return $tPoints
EndFunc   ;==>_CreatePointsStruct

Func WM_PAINT($hWnd, $uMsgm, $wParam, $lParam)
	_GDIPlus_GraphicsDrawImage($hGraphics, $hBmpBuffer, 0, 0)
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_PAINT

Func _Exit()
	For $i = 1 To $aDll[0][0]
		DllClose($aDll[$i][0])
	Next
	_GDIPlus_PenDispose($hPen)
	_GDIPlus_GraphicsDispose($hGfxBuffer)
	_GDIPlus_BitmapDispose($hBmpBuffer)
	_GDIPlus_GraphicsDispose($hGraphics)
	_GDIPlus_Shutdown()
	Exit
EndFunc   ;==>_Exit